'-- VA18B-Cons.bas --------------------------------------------- >>fst'14<< -
' - sample program for accessing VA18B.dll
' - shows data from a multimeter VA18B (Mastech)
' - compiled with Freebasic 0.24
'-- V 20140212 ------------------------------- http://www.FrankSteinberg.de -

Dim Comport_Auto As Function () As UInteger
'Tries to open the highest available Comport. 
'Success: Returns comport number.
'Fail:    Returns 0
Dim Comport_Open As Function (iPortNr As UInteger) As UInteger
'Tries to open given Comport. 
'Success: Returns comport number.
'Fail:    Returns 0
Dim Comport_Close As Function () As UInteger
'Tries to close previous opened Comport. 
'Success: Returns 0
'Fail:    Returns non-zero
Dim Comport_Buffer As Function () As UInteger
'Returns the number of unread bytes in comport-buffer.
'Dim DMM_Data As Sub (DMM_Value As ZString, DMM_Unit As ZString, DMM_AcDc As ZString, DMM_Info As ZString)
Dim DMM_Data As Sub (DMM_Value As ZString Ptr, DMM_Unit As ZString Ptr, DMM_AcDc As ZString Ptr, DMM_Info As ZString Ptr)
'Returns four strings containg the measure value:
'  1. Value (6 chars, empty string if overload),
'  2. Unit  (4 chars)
'  3. AcDc Value (2 chars)
'  4. Other infos from DMM or errormessages (different number of chars)	

'Due to compatibility we are using zero-terminated strings who needs to allocated before use: 
Dim DMM_Value As ZString * 7
Dim DMM_Unit  As ZString * 5
Dim DMM_AcDc  As ZString * 3
Dim DMM_Info  As ZString * 127

'Loading dll:
Dim hDLL As Any Ptr
hDLL = DylibLoad("VA18B.dll")
If(hDLL = 0) Then  'Errorhandling if loading fails
 Print "Missing  VA18B.dll"
 sleep
 End 1
End If

'Find adresses for dll-procedures:
Comport_Auto   = DyLibSymbol(hDLL, "Comport_Auto")
Comport_Open   = DyLibSymbol(hDLL, "Comport_Open")
Comport_Close  = DyLibSymbol(hDLL, "Comport_Close")
Comport_Buffer = DyLibSymbol(hDLL, "Comport_Buffer")
DMM_Data       = DyLibSymbol(hDLL, "DMM_Data")

'Open comport using auto-serarch for highest portnumber:
Print "Comport opened: ";  Comport_Auto()
'Alternatively open a specific portnumber (here COM23):
'Print "Comport opened: ";  Comport_Open(23)

'Show how is works to get number of bytes in comport-buffer:
Sleep(200)
Print "Bytes in buffer: "; Comport_Buffer()

Do  'Mainloop

	'Call Sub from VA18B.dll:
	DMM_Data(DMM_Value, DMM_Unit, DMM_AcDc, DMM_Info)
	'Show Data:
	Print DMM_AcDc; " "; DMM_Value; " "; WStr(DMM_Unit); " "; DMM_Info

Loop Until InKey <> ""  'any keystroke ends program

'Close comport:
Print "Comport closed: "; Comport_Close()
'Remove VA18B.dll from memory:
DyLibFree hDLL
'1 Sec to read message:
Sleep(1000)
