'-- VA18B-GUI.bas --------------------------------------------- >>fst'15<< -
' - sample program for accessing VA18B.dll
' - shows data from a multimeter VA18B (Mastech)
' - compiled with BCX & TinyC-Compiler
'   download from http://bc9.bcxbasic.com
'-- V 20150918 ------------------------------- http://www.FrankSteinberg.de -

'*** These batchfiles are automatically called to compile after translating with BCX:
'    (needs the corresponding c-compilers (tcc or MinGW or PellesC) to be installed!)
$ONEXIT "TC926_32.BAT $FILE$ -v" 
'$ONEXIT "GWGCC.BAT $FILE$ -m32 gui -Os"
'$ONEXIT "PEL.BAT $FILE$ -m32 gui"


GLOBAL AS HWND Form1
GLOBAL AS CONTROL hLabel_Info, hLabel_AcDC, hLabel_Unit, hLabel_Value, hStatusBar
GLOBAL AS String sTitle, sStatusText, sDMMValue, sDMMUnit, sDMMAcDC, sDMMInfo
GLOBAL AS UINT iPortNr, iCounter, idTimer, iComPort, iComBuffer

'*** Make prog a GUI, classname is "VA18B-GUI", use pixels as unit, load icon described with index 100 in 'RES\VA18B-GUI.rc'  
GUI "VA18B-GUI", PIXELS, ICON, 100

SUB FORMLOAD() '*** Create the GUI:
	
   sTitle = "VA18B-GUI    V20150918    >>fst'15<<"   

   'Global ENUM ID_Stc1=101, ID_Stc2, ID_Stc3, ID_Stc4
   Form1 = BCX_FORM(sTitle, 0, 0, 628, 222, WS_MINIMIZEBOX | WS_CAPTION | WS_SYSMENU)
   hLabel_Info = BCX_LABEL("----------------------",Form1, 00, 24, 16, 574, 32, WS_VISIBLE|WS_CHILD)
    BCX_SET_FONT(hLabel_Info,"Courier New", 20, 800, 0, 0, 0)
   hLabel_AcDC = BCX_LABEL("--",Form1, 00, 24, 96, 55, 36, WS_VISIBLE|WS_CHILD)
    BCX_SET_FONT(hLabel_AcDC,"Courier New", 28, 800, 0, 0, 0)
   hLabel_Unit = BCX_LABEL("----",Form1, 00, 488, 96, 107, 37, WS_VISIBLE|WS_CHILD)
    BCX_SET_FONT(hLabel_Unit,"Courier New", 28, 800, 0, 0, 0)
   hLabel_Value = BCX_LABEL("------",Form1, 00, 112, 64, 359, 98, WS_VISIBLE|WS_CHILD, WS_EX_STATICEDGE)
    BCX_SET_FONT(hLabel_Value,"Courier New", 72, 800, 0, 0, 0)
   hStatusBar = BCX_STATUS("Ready",Form1)
   CENTER(Form1)
   SHOW(Form1)
   
END SUB


BEGIN EVENTS  '***Event loop:
	
 SELECT CASE CBMSG
   
   CASE WM_CREATE  'Before Form1 is paint ...
    '*** Check, if dll ist present:
    If Not Exist("VA18B.dll") Then
	  MsgBox "Missing  VA18B.dll !", sTitle, MB_ICONERROR
	  END
	End If
	'*** Open Comport using VA18B.dll:
    iComPort = Comport_Auto(LIB "VA18B.dll")
	'** replace line above with the following to open a given comport (COM 27 for this example):
    'iComPort = Comport_Open(LIB "VA18B.dll", 27)
    If Not iComPort Then  'Errorhandling
	  MsgBox "Comport not available!", sTitle, MB_ICONERROR
	  END
	End If
	'Store message for statusbar:
	sStatusText = "Connected to COM" + Str$(iComPort) + Chr$(9) + "Dataframe Nr. "

   CASE WM_PAINT  'After Form1 is paint ...
    'Start timer for data-polling:
    idTimer = SetTimer(Form1, 1, 10, NULL)
	'Put message to statusbar:
    SetWindowText(hStatusBar, sStatusText)	
    
   CASE WM_TIMER  'Every 10 millisecond ...
    '*** Get a Dataframe from multimeter and show results:
    '    The 'DMM-Data' function (VA18B.dll) waits for a valid dataframe (timeout is 4 seconds). If we don't want to lock
    '    our program while waiting, we ca read the number of bytes waiting in comport buffer using the 'Comport_Buffer'
    '    function (VA18B.dll). A valid dataframe has 14 bytes. For a test uncomment following If / EndIf:
    iComBuffer = Comport_Buffer(LIB "VA18B.dll")  
    'If iComBuffer > 13 Then
      SetWindowText(hStatusBar,sStatusText + Str$(iCounter) + Chr$(9) + "ComBuffer: " + Str$(iComBuffer))
      '** Read data from multimeter:
      '   Data is strored in four strings 1. Measurement (6 bytes), 2. Unit (4 bytes), 3. Ac- or DC-indicator (2 bytes),
      '   4. The other Infos from display. Info contains also errormessages from VA18B.dll (bytecount is different).
      DMM_Data(LIB "VA18B.dll", sDMMValue, sDMMUnit, sDMMAcDC, sDMMInfo)
      SetWindowText(hLabel_Info,  sDMMInfo)  'show info (errormessages allways begin with a '*')
      SetWindowText(hLabel_AcDC,  sDMMAcDC)  'show Ac/DC indicator
      SetWindowText(hLabel_Value, sDMMValue) 'show value
      SetWindowText(hLabel_Unit,  sDMMUnit)  'show unit
      iCounter += 1   'increase dataframe-counter
    'End If
         
   CASE WM_CLOSE  'If user closes window ...
    KillTimer(Form1, idTimer)                   'Remove timer
    iComPort = Comport_Close(LIB "VA18B.dll")   'Close comport using VA18B.dll
    If iComPort Then MsgBox "Error closing comport!", sTitle, MB_ICONERROR   'Errrormessage
    END  'End application
   
 END SELECT
  
END EVENTS
