
;-- VA18B_GUI.au3----------------------------------------------- >>fst'14<< -
; - sample program for accessing VA18B.dll
; - shows data from a multimeter VA18B (Mastech)
; - tested with AutoIt 3.3.10.2 - www.autoitscript.com
;-- V 20140128 ------------------------------- http://www.FrankSteinberg.de -

#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <GuiStatusBar.au3>
#include <Constants.au3>

;*** Create the GUI:
Const $sTitel = "VA18B_GUI    V20130128    >>fst'14<<"
$hVA18B_GUI_Form = GUICreate($sTitel, 618, 210, -1, -1)
$hLabel_Value = GUICtrlCreateLabel("------", 104, 64, 359, 98, $SS_SUNKEN)
GUICtrlSetFont(-1, 72, 800, 0, "Courier New")
$hLabel_ACDC = GUICtrlCreateLabel("--", 24, 96, 55, 37)
GUICtrlSetFont(-1, 28, 800, 0, "Courier New")
$hLabel_Info = GUICtrlCreateLabel("----------------------", 24, 16, 574, 32)
GUICtrlSetFont(-1, 20, 800, 0, "Courier New")
$hLabel_Unit = GUICtrlCreateLabel("----", 488, 96, 107, 37)
GUICtrlSetFont(-1, 28, 800, 0, "Courier New")
$hStatusBar = _GUICtrlStatusBar_Create($hVA18B_GUI_Form)
GUISetState(@SW_SHOW)

;*** Load VA18B.dll:
$hDll = DllOpen("VA18B.dll")
If $hDll = -1 Then   ;Errorhandling if loading fails:
    MsgBox($MB_ICONERROR, $sTitel, "Error opening  VA18B.dll")
    Exit
EndIf

;*** Open Comport using VA18B.dll:
$aComPort = DllCall($hDll, "UInt", "Comport_Auto")
;** replace line above with the following one to open a given comport (COM 27 for this example):
;$aComPort = DllCall($hDll, "UInt", "Comport_Open", "UINT", 27)
If Not $aComPort[0] Then  ;Errorhandling
  MsgBox($MB_ICONERROR, $sTitel, "Comport not available!")
  Exit
EndIf
;Put message to statusbar:
$sStatusText = "Connected to COM " & $aComPort[0] & @TAB & "Dataframe Nr. "
_GUICtrlStatusBar_SetText($sStatusText)

$iCounter = 0

;*** Mainloop:
While 1

	$nMsg = GUIGetMsg()        ;get windows messages
	Switch $nMsg
		Case $GUI_EVENT_CLOSE  ;if user closes window ...
		$aComPortClose = DllCall($hDll, "UInt", "Comport_Close")  ;close comport using VA18B.dll
		If $aComPortClose Then MsgBox($MB_ICONERROR, $sTitel, "Error closing COM" & $aComPort[0])  ;errrormessage
		Exit
	EndSwitch

    ;*** Get a Dataframe from multimeter and show results:
    ;    The 'DMM-Data' function (VA18B.dll) waits for a valid dataframe (timeout is 4 seconds). If we don't want to lock
    ;    our program while waiting, we ca read the number of bytes waiting in comport buffer using the 'Comport_Buffer'
    ;    function (VA18B.dll). A valid dataframe has 14 bytes. For a test uncomment following If / EndIf:
    ;If $aComBuffer[0] > 13 Then
 		$aComBuffer = DllCall($hDll, "UInt", "Comport_Buffer")  ;read number of bates in comport buffer
		_GUICtrlStatusBar_SetText($hStatusBar, $sStatusText & $iCounter & @TAB & "ComBuffer: " & $aComBuffer[0]) ;... and show in statusbar
		;** Read data from multimeter:
        ;   Data is strored in four strings 1. Measurement (6 bytes), 2. Unit (4 bytes), 3. Ac- or DC-indicator (2 bytes),
        ;   4. The other Infos from display. Info contains also errormessages from VA18B.dll (bytecount is different).
        $aDMMData = DllCall($hDll, "none", "DMM_Data", "Str", "Value", "Str", "Unit", "Str", "AcDC", "Str", "Info")
		GUICtrlSetData($hLabel_Value, $aDMMData[1])  ;show value
		GUICtrlSetData($hLabel_Unit,  $aDMMData[2])  ;show unit
		GUICtrlSetData($hLabel_ACDC,  $aDMMData[3])  ;show Ac/DC indicator
		GUICtrlSetData($hLabel_Info,  $aDMMData[4])  ;show info (errormessages allways begin with a '*')
        $iCounter += 1  ;increase dataframe-counter
    ;EndIf

WEnd

